################################################################
# Modifications beyond tkWWW 0.9 are Copyright 1993, 1994 by
# The University of Chicago Biological Sciences Division, Academic Computing
# Philip Stylianos
# Lee Newberg
################################################################

proc phxW3CurrentHtext {} {

	global CurrentHtext
	return $CurrentHtext
}

proc phxW3CurrentFrame {{frame ""}} {

	global CurrentFrame
	if {$frame != ""} {
		set CurrentFrame $frame
	}
	return $CurrentFrame
}

proc phxW3CacheHtextNewName {} {
	return .f.[phxW3WidgetNewName msg]	
}


proc phxW3CacheUncache {URL} {
    global phxW3Cache

    tkW3NavigateServerSend [list HtUncache $URL]
    if {[info exists phxW3Cache($URL)]} {
	destroy [lindex $phxW3Cache($URL) 1]
	unset phxW3Cache($URL)
    }
}

proc phxW3CacheLoadPageFromServer {URL} {

    global phxW3Cache
    global CurrentHtext

    # Assume success
    set failure 0

    # Search for the URL in the in-cache array
    if {[catch {set entry $phxW3Cache($URL)}] == 0} {

	# We've got it cached.

	# The widget name is the second member of the list
	set htext [lindex $entry 1]

	# The HTML title is the third member of the list
	set title [lindex $entry 2]

	# Replace current hypertext widget (if any) with the summoned one
	if {[info exists CurrentHtext]} {pack forget $CurrentHtext}
	pack $htext -side top -fill both

	# Now the summonened htext is the current htext
	set CurrentHtext $htext
	phxW3CurrentFrame $htext.frame

	tkW3OutputSetAddress $URL $title
    } else {

	# Must build a new htext
	# Get a new name for the htext widget
	set htext [phxW3CacheHtextNewName]

	# Replace current hypertext widget (if any) with the summoned one
	phxW3OutputMakeHtext $htext
	if {[info exists CurrentHtext]} {pack forget $CurrentHtext}
	pack $htext -side top -fill both

	# Now the summonened htext is the current htext
	set CurrentHtext $htext

	# Load in the normal way
	set failure [tkW3NavigateLoadPageFromServer $URL]

	# Use URL as the index into the phxW3Cache array.
	# (Tcl can handle it even though it may contain spaces.)
	if {!$failure} {
	    # Because of possible URL forwarding, we can't use $URL.
	    phxW3CacheAdd [tkW3OutputGetAddress] $htext [tkW3OutputGetTitle]
	}
    }
    update idletasks
    return $failure
}

proc phxW3CacheAdd {file htext title} {
    global phxW3Cache
    set phxW3Cache($file) [list $file $htext $title]
}

proc phxW3CacheGet {file} {
    global phxW3Cache
    if {[info exists phxW3Cache($file)]} {
	return $phxW3Cache($file)
    } else {
	return {}
    }
}

proc phxW3CacheRename {old newURL newTitle} {
    global phxW3Cache
    if {[info exists phxW3Cache($old)]} {
	# It'd be nice if we could rename in the back-end's cache, but
	# we'll have to settle for invalidating the old entry.
	tkW3NavigateServerSend [list HtUncache $old]

	phxW3CacheAdd $newURL [lindex $phxW3Cache($old) 1] $newTitle
	unset phxW3Cache($old)
    }
}
