################################################################
# Modifications beyond tkWWW 0.9 are Copyright 1993, 1994 by
# The University of Chicago Biological Sciences Division, Academic Computing
# Philip Stylianos
# Lee Newberg
################################################################

proc phxW3InfoShowInfo {} {

	set info "\n"
	append info "Title\n[tkW3OutputGetTitle]\n\n"
	append info "Address\n[tkW3OutputGetAddress]\n\n"
	if {[phxW3InfoFileEditable [tkW3OutputGetAddress]] != ""} {
		append info "This file is EDITABLE.\n\n"
	} else {
		append info "This file is not editable.\n\n"
	}
	if [tkW3AnnotateDisplay] {
		append info "Annotations available\n\n"
	}
	global tkW3NavigateIsIndex
	if {$tkW3NavigateIsIndex} {
		append info "This page is an index\n\n"
	}
	DLG:information . .info $info "Dismiss"

}

# phxW3InfoFileEditable
# Returns the full path name if the file is editable.
# Otherwise returns ""

proc phxW3InfoFileEditable {url} {
    set url [phxW3InfoConvertToFile $url]
    set x {^([^:/#?]+:)?(//([^:/#?]+)(:[0-9]+)?)?([^:#?]+)?(#[^/#?]+)?(\?[^:/#?]+)?$}
    regexp $x $url url method hostport host port path anchor query
    if {$method != "file:" || ![file writable $path]} {set path ""}
    return $path
}

# phxW3InfoConvertToFile
# If the url is http: for some computer we understand, then
# convert to a file:

proc phxW3InfoConvertToFile {url} {
    global phxW3ConfigHTTPdRoots
    set x {^([^:/#?]+:)?(//([^:/#?]+)(:[0-9]+)?)?([^:#?]+)?(#[^/#?]+)?(\?[^:/#?]+)?$}
    if {[regexp $x $url url method hostport host port path anchor query]} {
	if {$method == "http:"} {
	    set index [lsearch -glob $phxW3ConfigHTTPdRoots "$host *"]
	    if {$index >= 0} {
		set HTTPdRoot [lindex [lindex $phxW3ConfigHTTPdRoots $index] 1]
		set url file:$hostport$HTTPdRoot$path$anchor$query
	    }
	}
    }
    return $url
}

# phxW3InfoConvertToHTTP
# If the url is file: for some computer we understand then, if
# possible, convert it to http:

proc phxW3InfoConvertToHTTP {url} {
    global phxW3ConfigHTTPdRoots
    set x {^([^:/#?]+:)?(//([^:/#?]+)(:[0-9]+)?)?([^:#?]+)?(#[^/#?]+)?(\?[^:/#?]+)?$}
    if {[regexp $x $url junk method hostport host port path anchor query]} {
	if {$method == ""} {
	    set method "file:"
	    set url $method$hostport$path$anchor$query
	}
	if {$method == "file:"} {
	    if {$host == ""} {
		# This is highly non-portable!!!
		set host www.bsd.uchicago.edu 
		set hostport //$host$port
	    }
	    set index [lsearch -glob $phxW3ConfigHTTPdRoots "$host *"]
	    if {$index >= 0} {
		set HTTPdRoot [lindex [lindex $phxW3ConfigHTTPdRoots $index] 1]
		if {[regexp ^${HTTPdRoot}(.*) $path junk extension]} {
		    set url http:$hostport$extension$anchor$query
		}
	    }
	}
    }
    return $url
}