################################################################
# Modifications beyond tkWWW 0.9 are Copyright 1993, 1994 by
# The University of Chicago Biological Sciences Division, Academic Computing
# Philip Stylianos
# Lee Newberg
################################################################

## version.tcl - Verify version of the server
## ==============
## Copyright (C) 1992-1993
## Global Network Academy
## Macvicar Institute for Educational Software Development
##
## See the file COPYRIGHT for conditions

## This file performs version control

## phxW3VersionVerify: Verify the version of the server
## ----------

proc phxW3VersionVerify {version} {
    set server_version [tkW3NavigateServerSend "HtVersion"]
    if ![regexp {^([0-9]+).([0-9]+)} $server_version version_num major minor] {
	puts stderr "Warning: Cannot find version of phoenix.server"
	return;
    }
    if {$major!=0 && $minor != 0} {
	puts stderr \
"Error: Phoenix front-end is incompatible with phoenix.server\n\
front-end version: $version  server version: $server_version\n\
You must recompile the phoenix.server"
      exit 1
   }
   if {$version_num != $version} {
      puts stderr \
"Warning: Front-End version is different from server version\n\
front-end version: $version  server version: $server_version"
   }
}     
